package org.graphavik.api.example;

import org.graphavik.api.annotations.GraphId;
import org.graphavik.api.annotations.GraphProperty;
import org.graphavik.api.annotations.NodeEntity;

import java.util.HashSet;
import java.util.Set;

/**
 * Base class for all locations.
 *
 * @author Michail Nikolaev
 * @since <b>version 0.1</b>
 *        <i>created: 07.10.12</i>
 */
@NodeEntity
public abstract class AbstractLocation {
    private Long id;
    // optional @GraphProperty skipped
    private String name;
    @GraphProperty(mappedTo = "aliases_list")
    private Set<String> aliases = new HashSet<String>();

    @GraphId
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Set<String> getAliases() {
        return aliases;
    }
}
