package org.graphavik.api.example;

import org.graphavik.api.annotations.Fetch;
import org.graphavik.api.annotations.GraphTraversal;
import org.graphavik.api.annotations.Query;
import org.graphavik.api.annotations.RelatedToVia;
import org.graphavik.api.example.traversal.KnowsMeNames;
import org.graphavik.api.example.traversal.KnowsMeWithSameName;

import java.util.Set;

/**
 * Class for represent humanoid.
 *
 * @author Michail Nikolaev
 * @since <b>version 0.1</b> <i>created: 09.10.12</i>
 */
public class Humanoid extends AbstractIntelligentCreature {
    public static final String LOCATED_LABEL = "located";
    @RelatedToVia(type = LOCATED_LABEL)
    private Set<LocatedIn> locatedIn;

    @GraphTraversal(KnowsMeNames.class)
    public Iterable<String> knowsMeNames;
    @GraphTraversal(KnowsMeWithSameName.class)
    public Iterable<Humanoid> knowsWithSameName;
    @Query(value = "_().out('knows').has('name', ${name}).out(located).has('name', ${0})", params =  "Minsk")
    public Iterable<AbstractLocation> everyLocationWithCreatureIKnownWithSameName;

    // @RelatedToVia on collection, but fetch on method
    @Fetch
    public Set<LocatedIn> getLocatedIn() {
        return locatedIn;
    }

    public void setLocatedIn(Set<LocatedIn> locatedIn) {
        this.locatedIn = locatedIn;
    }
}
