package org.graphavik.api.example;

import org.graphavik.api.annotations.EndNode;
import org.graphavik.api.annotations.GraphId;
import org.graphavik.api.annotations.GraphProperty;
import org.graphavik.api.annotations.RelationshipEntity;
import org.graphavik.api.annotations.StartNode;

import java.util.Date;

/**
 * Relation type to determine location of creature.
 *
 * @author Michail Nikolaev
 * @since <b>version 0.1</b>
 *        <i>created: 07.10.12</i>
 */
@RelationshipEntity
public class LocatedIn {
    public static final String SINCE_PROPERTY = "since";
    @GraphId
    private String id;
    @StartNode
    protected AbstractIntelligentCreature creature;
    @EndNode
    protected AbstractLocation location;

    @GraphProperty(mappedTo = SINCE_PROPERTY)
    private Date locatedSince;

    public String getId() {
        return id;
    }

    public Date getLocatedSince() {
        return locatedSince;
    }

    public void setLocatedSince(Date locatedSince) {
        this.locatedSince = locatedSince;
    }

    public AbstractIntelligentCreature getCreature() {
        return creature;
    }

    public AbstractLocation getLocation() {
        return location;
    }
}
