package org.graphavik.api.example;

import org.graphavik.api.annotations.GraphProperty;

import javax.sql.rowset.serial.SerialBlob;
import java.util.Map;

/**
 * Class to represent planet.
 *
 * @author Michail Nikolaev
 * @since <b>version 0.1</b>
 *        <i>created: 07.10.12</i>
 */
public class Planet extends AbstractLocation {
    // TODO(Michail Nikolaev): tests for set, list and collection of primitives
    // TODO(Michail Nikolaev): indexes disallowed in such case
    @GraphProperty
    private Double[] coordinates = new Double[4];
    @GraphProperty // map from primitive to serializable
    private Map<Integer, SerialBlob> knowledgeDatabase;
    // serializable object
    @GraphProperty(mappedTo = "pub_info")
    private SerialBlob publicInformation;

    public Double[] getCoordinates() {
        return coordinates;
    }

    public void setCoordinates(Double[] coordinates) {
        this.coordinates = coordinates;
    }

    public Map<Integer, SerialBlob> getKnowledgeDatabase() {
        return knowledgeDatabase;
    }

    public void setKnowledgeDatabase(Map<Integer, SerialBlob> knowledgeDatabase) {
        this.knowledgeDatabase = knowledgeDatabase;
    }
}
