package org.graphavik.api.example.traversal;

import com.tinkerpop.blueprints.Direction;
import com.tinkerpop.blueprints.Edge;
import com.tinkerpop.blueprints.Graph;
import com.tinkerpop.blueprints.Vertex;
import org.graphavik.api.example.AbstractIntelligentCreature;
import org.graphavik.api.traversal.Traversal;

import java.util.HashSet;
import java.util.Set;

/**
 * Traversal to get creatures with name as my and which are knows me.
 *
 * @author Michail Nikolaev
 * @since <b>version 0.1</b> <i>created: 09.10.12</i>
 */
public class KnowsMeWithSameName implements Traversal<Vertex> {
    @Override
    public Iterable<Vertex> processVertex(String[] params, Vertex vertex, Graph graph)
            throws UnsupportedOperationException {
        Set<Vertex> results = new HashSet<Vertex>();
        String myName = vertex.getProperty(AbstractIntelligentCreature.NAME_FILED).toString();
        // may be implemented using gremlin language
        for (Vertex v : vertex.getVertices(Direction.IN, AbstractIntelligentCreature.KNOW_TYPE)) {
            if (myName.equals(v.getProperty(AbstractIntelligentCreature.NAME_FILED).toString())) {
                results.add(v);
            }
        }
        return results;
    }

    @Override
    public Iterable<Vertex> processEdge(String[] params, Edge edge, Graph graph) throws UnsupportedOperationException {
        throw new UnsupportedOperationException();
    }

    @Override
    public Class<Vertex> getTargetClass() {
        return Vertex.class;
    }
}
