package org.graphavik.api.annotations;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Optional annotation to declare property stored in graph.
 * <p/>
 * To get info about supported type see {@link com.tinkerpop.blueprints.Features} for {@code supports*Property} to get
 * info about supported types.
 * <p/>
 * <b>TODO(Michail Nikolaev): write about conversion services</b>
 *
 * @author Michail Nikolaev
 * @see com.tinkerpop.blueprints.Graph#getFeatures()
 * @since <b>version 0.1</b> <i>created: 07.10.12</i>
 */
@Retention(RetentionPolicy.RUNTIME)
@Target({ ElementType.FIELD, ElementType.METHOD })
public @interface GraphProperty {
    /**
     * @return property name at graph side to use
     */
    String mappedTo() default "";

    /**
     * @return should property be store in the graph
     */
    boolean isTransient() default false;
}
