package org.graphavik.api.annotations;

/**
 * Used to mark field {@link GraphProperty} as indexed. Different index type should be registered previously.
 * <p/>
 * TODO(Michail Nikolaev): index registering
 *
 * @author Michail Nikolaev
 * @since <b>version 0.1</b> <i>created: 10.10.12</i>
 */
public @interface Indexed {
    public static final String DEFAULT_INDEX_TYPE = "default";

    /**
     * @return index name to use
     */
    String value() default "";

    /**
     * @return type of index to use (should be registered)
     */
    String indexType() default DEFAULT_INDEX_TYPE;
}
