package org.graphavik.api.annotations;

import com.tinkerpop.blueprints.Direction;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Used on field in {@link NodeEntity} to declare collection of {@link RelationshipEntity}.
 * <p/>
 * TODO(Michail Nikolaev): throw if annotated on field.
 *
 * @author Michail Nikolaev
 * @since <b>version 0.1</b> <i>created: 09.10.12</i>
 */
@Retention(RetentionPolicy.RUNTIME)
@Target({ ElementType.FIELD, ElementType.METHOD })
public @interface RelatedToVia {
    /**
     * @return type of relation, field name+class name by default.
     */
    String type() default "";

    /**
     * @return direction of relation.
     */
    Direction direction() default Direction.OUT;
}
