package org.graphavik.api.annotations;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Represents start of relation in {@link RelationshipEntity}.
 * <p/>
 * <b>Note:</b>Start node is readonly field (update are ignored).
 *
 * @author Michail Nikolaev
 * @see RelationshipEntity
 * @since <b>version 0.1</b> <i>created: 09.10.12</i>
 */
@Retention(RetentionPolicy.RUNTIME)
@Target({ ElementType.FIELD, ElementType.METHOD })
public @interface StartNode {
}
